void setHUD() {
  cam.beginHUD();
  noStroke();
  textFont(myHelvetica25);
  fill(255);
  strokeWeight(15); //point size
  text("Spatio-temporal Visualization of Human Development Index (HDI)", guiMarginX, guiMarginY-50);
  textFont(myHelvetica15);
  text(yearNumber[yearChoice], guiMarginX+buttonWidth+5,guiMarginY+(buttonHeight+5)*4+5);
  //legend
  for (int i=0; i<4; i++) {
    if (legendValues[i]) {
      alpha = pointTransparency+ pointTransparency*noise(i*millis());
      int fillR = colorScheme[i][0];
      int fillG = colorScheme[i][1];
      int fillB = colorScheme[i][2];
      stroke(fillR, fillG, fillB, alpha);
      point(legendMarginX, legendMarginY+i*1.5*15);
      //textFont(myHelvetica15);
      fill(255);
      noStroke();
      text(legendText[i], legendMarginX+1.5*15, legendMarginY+i*1.5*15+5);
    } 
  }  
  cam.endHUD();
}

void drawMDS() {
  cam.beginHUD();
  fill(255);
  //fill(130);
  textFont(myHelvetica15);
  textAlign(CENTER, CENTER);
  text("HDI Pattern", (mdsStartX+mdsEndX)/2, mdsEndY-25);
  smooth();
  strokeWeight(1);
  stroke(130);
  fill(0,0,0,0);
  rect(mdsStartX-10, mdsEndY-10, mdsEndX-mdsStartX+20, mdsStartY-mdsEndY+20);
  fill(227,26,28,130);
  //int textCount = 0;
  for (int i=0; i< mdsRows; i++) {
      // min(-mdsData(:,1)) = -6.5945;  max(-mdsData(:,1)) = 4.8246;  min(-mdsData(:,2)) = -1.6772;  max(-mdsData(:,2)) = 1.0900
      ellipse(pXList[i],pYList[i],10,10); // 10 is the radius of the circle
  }
  
  if (mouseX<=mdsEndX+20 && mouseX>=mdsStartX-10 && mouseY<=mdsStartY+10 && mouseY>= mdsEndY-10) {
    //int textCount = 0;
    ArrayList<Float> buffDistList = new ArrayList<Float>();
    ArrayList<Integer> buffDistIndex = new ArrayList<Integer>();
    for (int i=0; i< mdsRows; i++) {
      float pBuffDist = dist(mouseX,mouseY,pXList[i],pYList[i]);
      if (pBuffDist<=10) {
        //textCount++;
        buffDistIndex.add(i);
        buffDistList.add(pBuffDist);    
      }
    }
    if (!buffDistList.isEmpty()) {
      float minDist = Collections.min(buffDistList);
      int buffInd = buffDistList.indexOf(minDist);
      int textInd = buffDistIndex.get(buffInd);
      String countryName = hdiData[textInd][0];
      stroke(255);
      fill(255,0,0);
      ellipse(pXList[textInd],pYList[textInd],10,10); // 10 is the radius of the circle
      fill(160);
      text(countryName, (mdsStartX+mdsEndX)/2, mdsStartY + 25+10);
      
      // draw trend
      fill(255);
      textFont(myHelvetica15);
      textAlign(CENTER, CENTER);
      text("HDI Trend", (mdsStartX+mdsEndX)/2, mdsStartY+60);
      smooth();
      strokeWeight(1);
      stroke(130);
      fill(0,0,0,0);
      rect(trendStartX-10, trendEndY-10, trendEndX-trendStartX+20, trendStartY-trendEndY+20);
      fill(130);
      for (int j=0; j<40; j++) {
        line(trendStartX+10+(trendEndX-trendStartX-10)/40*j,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/40*j, trendStartY-6+10);
      }
      line(trendStartX+10,trendStartY+10,trendStartX+10, trendStartY-10+10);
      line(trendStartX+10+(trendEndX-trendStartX-10)/4,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/4, trendStartY-10+10);
      line(trendStartX+10+(trendEndX-trendStartX-10)/4*2,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/4*2, trendStartY-10+10);
      line(trendStartX+10+(trendEndX-trendStartX-10)/4*3,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/4*3, trendStartY-10+10);
      line(trendStartX+10+(trendEndX-trendStartX-10)/4*3,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/4*3, trendStartY-10+10);
      line(trendStartX+10+(trendEndX-trendStartX-10)/4*4,trendStartY+10,trendStartX+10+(trendEndX-trendStartX-10)/4*4, trendStartY-10+10);
      text("1980", trendStartX+10,trendStartY+10+10);
      text("1990", trendStartX+10+(trendEndX-trendStartX-10)/4,trendStartY+10+10);
      text("2000", trendStartX+10+(trendEndX-trendStartX-10)/4*2,trendStartY+10+10);
      text("2010", trendStartX+10+(trendEndX-trendStartX-10)/4*3,trendStartY+10+10);
      text("2020", trendStartX+10+(trendEndX-trendStartX-10)/4*4,trendStartY+10+10);
      
      float trendTick1Y = map(0.3, 0,1,trendStartY+10,trendEndY-10);
      line(trendStartX-10, trendTick1Y, trendStartX-10+6, trendTick1Y);
      text("0.3", trendStartX-10-20, trendTick1Y);
      
      float trendTick2Y = map(0.6, 0,1,trendStartY+10,trendEndY-10);
      line(trendStartX-10, trendTick2Y, trendStartX-10+6, trendTick2Y);
      text("0.6", trendStartX-10-20, trendTick2Y);
      
      float trendTick3Y = map(0.9, 0,1,trendStartY+10,trendEndY-10);
      line(trendStartX-10, trendTick3Y, trendStartX-10+6, trendTick3Y);
      text("0.9", trendStartX-10-20, trendTick3Y);
      
      fill(0,255,0);
      for (int k=0; k<9; k++) {
        if (!hdiData[textInd][1+k].equals("Null")) {
          float hdiValue = Float.parseFloat(hdiData[textInd][1+k]);
          //min of hdivalue is 0.1910, max is 0.9440
          float pY = map(hdiValue, 0,1,trendStartY+10,trendEndY-10);
          ellipse(trendXPos[k],pY,7,7); // 10 is the radius of the circle
        }
      }
      
  
      
    } 
    
    
  }
  
  fill(130);
  float tick1X = map(-4, -6.5945, 4.8246, mdsStartX, mdsEndX);
  float tick1Y = map(-1, -1.6772, 1.0900, mdsStartY,mdsEndY);
  line(tick1X, mdsStartY+10, tick1X, mdsStartY-6+10);
  line(mdsStartX-10, tick1Y, mdsStartX-10 + 6, tick1Y);
  text("-4", tick1X,  mdsStartY + 10+10);
  text("-1", mdsStartX-20, tick1Y);
  
  float tick2X = map(0, -6.5945, 4.8246, mdsStartX, mdsEndX);
  float tick2Y = map(0, -1.6772, 1.0900, mdsStartY,mdsEndY);
  line(tick2X, mdsStartY+10, tick2X, mdsStartY-6+10);
  line(mdsStartX-10, tick2Y, mdsStartX-10 + 6, tick2Y);
  text("0", tick2X,  mdsStartY + 10+10);
  text("0", mdsStartX-20, tick2Y);
  
  float tick3X = map(4, -6.5945, 4.8246, mdsStartX, mdsEndX);
  float tick3Y = map(1, -1.6772, 1.0900, mdsStartY,mdsEndY);
  line(tick3X, mdsStartY+10, tick3X, mdsStartY-6+10);
  line(mdsStartX-10, tick3Y, mdsStartX-10 + 6, tick3Y);
  text("4", tick3X,  mdsStartY + 10+10);
  text("1", mdsStartX-20, tick3Y);
  
  cam.endHUD();
}
