void draw() {
  background(0);
  //code to deactivate peasycam rotations when sliders are active
  if (controlP5.window(this).isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }

  for (int i=0; i<dataRows; i++) {
    
    if (!hdiData[i][1+yearChoice].equals("Null")) {
      int colorSelector = Integer.parseInt(hdiData[i][12]) - 1;
      if (colorSelector == 0 && legendValues[0] || 
          colorSelector == 1 && legendValues[1] ||
          colorSelector == 2 && legendValues[2] ||
          colorSelector == 3 && legendValues[3]) {
        stroke(colorChooser(i, colorSelector));
        float weightedPointSize = pointSize*Float.parseFloat(hdiData[i][1+yearChoice]);
        String countryName = hdiData[i][0];
        strokeWeight(weightedPointSize);
        pushMatrix();
        //translate(0,0,100);
        float lng = radians(Float.parseFloat(hdiData[i][11]));
        float lat = radians(Float.parseFloat(hdiData[i][10]));
        
        drawPoint(lat, lng);
        
        if (labelOnValue) {
          //display name
          pushMatrix();
          translate(0,0,100+4);
          boolean flipLabel = false;
          if (cam_angle_Y > 0) {
              if (lng > cam_angle_Y || lng < behind_cam_angle_Y)
                flipLabel = true;
            }
            else {
              if (lng > cam_angle_Y && lng < behind_cam_angle_Y)
                flipLabel = true;
            }
    
            if (flipLabel ){
              rotateY(-PI/2.0);
              textAlign(LEFT, CENTER);
            }
            else {
              rotateY(PI/2.0);
              textAlign(RIGHT, CENTER);
            }
    
          // Draw location label
          fill(labelColor);
          //smooth();
          //noStroke();
          //textFont(myHelvetica15);
          textSize(map(weightedPointSize, 0, pointSize, 3, 5));
          if (countryName.equals("Congo")) {
            text(countryName, 0, -2);
          }
          else if (countryName.equals("Congo (Democratic Republic of the)")){
            text(countryName, 0, 2);
          }
          else if (countryName.equals("Saudi Arabia")) {
            text(countryName, 0, -2);
          }
          else if ( countryName.equals("Senegal")) {
            text(countryName, 0, 2);
          }
          else {
            text(countryName, 0, 0);
          }
          popMatrix();
          
        }
        
        
        
        // draw gradient line
        float lineDeltaZ = 100;
        int numSegments = 100;
        float tStep = 1.0/numSegments;
        float t = 0;
        strokeWeight(0.2);
        for (int j=0; j<numSegments; j++) {
          float nextT = t + tStep;
          stroke(255-220*j/(numSegments-1));
          line(0,0,0+lineDeltaZ*t, 0,0,0+lineDeltaZ*nextT);
          t=nextT;
        }
        popMatrix();
      }
    }
  }
  textAlign(LEFT, BASELINE);

  noStroke();
  fill(231,123,128);
  lights();
  pushMatrix();
  //translate(width/2, height/2, 0);
  strokeWeight(0.2);
  sphereDetail(360/15, 180/15); 
  sphere(3);
  if (globeOnValue) {
    noFill();
    stroke(125);
    sphere(100);
  }
  popMatrix();
  
  //popMatrix();// translating the sphere to the left
  
  drawGUI();
  setHUD();
  if (HDIPatternValue) {
    drawMDS();
  }
  //drawSimilarityMatrix();
}

void drawPoint(float lat, float lng) {
  //translate(width/2, height/2, 0);
  rotateY(lng);
  rotateX(lat);
  point(0,0,100);
}


color colorChooser(int i, int colorSelector) {
  alpha = pointTransparency+ pointTransparency*noise(i*millis());
  //int colorSelector = Integer.parseInt(hdiData[i][12]) - 1;
  int fillR = colorScheme[colorSelector][0];
  int fillG = colorScheme[colorSelector][1];
  int fillB = colorScheme[colorSelector][2];
  return color(fillR,fillG,fillB, alpha);
}



